program labyrinth;

{$APPTYPE CONSOLE}

const
  nmax = 1000;
  lsize = 100000;

type pair = record
  i, j: integer;
end;

var
  i, j, n, m, lb, ub, si, sj, di, dj: integer;
  a: array[0..nmax, 0..nmax] of char;
  queue: array[0..lsize] of pair;
  found: boolean;
  tp: pair;

begin
  assignfile(input, 'input.txt'); reset(input);
  assignfile(output, 'output.txt'); rewrite(output);

  readln (n, m); si := 0; sj := 0;
  for i := 1 to n do
  begin
    for j := 1 to m do
    begin
       read(a[i][j]);
       if a[i][j] = 'S' then begin si := i; sj := j; end;
    end;
    readln;
  end;

  lb := 0; ub := 1;
  queue[1].i := si; queue[1].j := sj; found := false;
  while (lb <> ub) and (not found) do
  begin
    lb := (lb + 1) mod lsize;
    tp := queue[lb];
    for di := -1 to 1 do
      for dj := -1 to 1 do
        if ((di = 0) xor (dj = 0)) and (tp.i + di >= 1) and (tp.i + di <= n) and
        (tp.j + dj >= 1) and (tp.j + dj <= m) then
        begin
          if a[tp.i + di][tp.j + dj] = 'F' then found := true;
          if a[tp.i + di][tp.j + dj] = '.' then
          begin
            a[tp.i + di][tp.j + dj] := '#';
            ub := (ub + 1) mod lsize;
            queue[ub].i := tp.i + di;
            queue[ub].j := tp.j + dj;
          end;
        end;
  end;

  if found then writeln('YES') else writeln('NO');

  closefile(input); closefile(output);
end.